#ifndef __EMC_NORFLASH_H_
#define __EMC_NORFLASH_H_

#include "lpc177x_8x_emc.h"

/*****************************************************************************
 * Defines and typedefs
 ****************************************************************************/
#define NOR_FLASH_BASE		0x80000000
#define NOR_FLASH_SIZE		0x00400000

#define GET_ADDR(addr)	(volatile uint16_t *)(NOR_FLASH_BASE | (addr<<1))


#define SECTOR_SIZE		0x800	/* Must be 2048 words for 39VF160 */
#define BLOCK_SIZE		0x8000	/* Must be 32K words for 39VF160  */

#define SST_ID			0xBF    /* SST Manufacturer's ID code   */
#define SST_39VF320		0x235B  /* SST 39VF160 device code      */

#define PROGRAM_TIMEOUT	 0x080000000

extern void NORFLASHInit( void );
extern void NORFLASHErase( void );
extern uint32_t NORFLASHCheckID( void );
extern uint32_t NORFLASHWriteWord( uint32_t Addr, uint16_t Data );
extern uint32_t ToggleBitCheck( uint32_t Addr, uint16_t Data );

#endif 
