/****************************************Copyright (c)****************************************************
**                               Guangzhou ZHIYUAN electronics Co.,LTD.
**                                     
**                                 http://www.embedtools.com
**
**--------------File Info---------------------------------------------------------------------------------
** File Name:               Main.c
** Last modified Date:      2007.01.18
** Last Version:            1.0
** Description:             The main function example template  ģ
*********************************************************************************************************/


#include <includes.h>
#include <cortexm3.h>

/*********************************************************************************************************
  CONSTANTS 
*********************************************************************************************************/
#define LED_NUM     2                  /* Number of user LEDs                */

const unsigned long led_mask[] = { 1<<2, 1<<3, 1<<4, 1<<5 };

/*********************************************************************************************************
  VARIABLES 
*********************************************************************************************************/
static OS_STK  GstkStart[TASK_START_STK_SIZE];                          /*  The stack of start task     */
                                                                        /*  Ķջ              */
static OS_STK  GstkLed1[TASK_LED1_STK_SIZE];                              /*  LedĶջ             */
static OS_STK  GstkLed2[TASK_LED2_STK_SIZE];                              /*  LedĶջ             */

static OS_STK  Gstkkey[TASK_key_STK_SIZE];                              /*  LedĶջ             */


static OS_EVENT *task1_Sem;
static OS_EVENT *task2_Sem;
static OS_EVENT *task3_Sem;

extern unsigned char Bg_16bpp_t_fh_fv[];
extern unsigned char Bg_16bpp_l_fh_fv[];

/*********************************************************************************************************
   FUNCTION PROTOTYPES 
*********************************************************************************************************/
static void taskStart (void  *parg);                                    /*  The start task      */
static void taskLed1 (void  *parg);
static void taskLed2 (void  *parg);
static  void  task_key (void  *parg);

volatile unsigned long SysTickCnt;

void wait( void)
{
	int i,j;
	for(i=0; i<1000; i++)
		for(j=0; j<5000; j++);
}

/*********************************************************************//**
 * @brief		Led
 * @param[in]	None
 * @return 		int
 **********************************************************************/
void Led1 (void)
{
	uint8_t value = 0;

	GPIO_SetDir(BRD_LED_1_CONNECTED_PORT, BRD_LED_1_CONNECTED_MASK, GPIO_DIRECTION_OUTPUT);

		GPIO_OutputValue(BRD_LED_1_CONNECTED_PORT, BRD_LED_1_CONNECTED_MASK, value);

		value = !value;

		OSTimeDly(500);

		GPIO_OutputValue(BRD_LED_1_CONNECTED_PORT, BRD_LED_1_CONNECTED_MASK, value);
}


void Led2(void)
{
	uint8_t value = 0;

	GPIO_SetDir(BRD_LED_2_CONNECTED_PORT, BRD_LED_2_CONNECTED_MASK, GPIO_DIRECTION_OUTPUT);

		GPIO_OutputValue(BRD_LED_2_CONNECTED_PORT, BRD_LED_2_CONNECTED_MASK, value);

		value = !value;
		  
		OSTimeDly(500);

		GPIO_OutputValue(BRD_LED_2_CONNECTED_PORT, BRD_LED_2_CONNECTED_MASK, value);

}
void GPIO_Configuration(void)
{
/*JOYSITCK  A(P2_25)  B(P2_26)  C(P2_23)  D(P2_19)  PRESS(P0_14)*/
	GPIO_SetDir(2, (1<<25), GPIO_DIRECTION_INPUT);
	GPIO_SetDir(2, (1<<26), GPIO_DIRECTION_INPUT);
	GPIO_SetDir(2, (1<<23), GPIO_DIRECTION_INPUT);
	GPIO_SetDir(2, (1<<19), GPIO_DIRECTION_INPUT);
	GPIO_SetDir(0, (1<<14), GPIO_DIRECTION_INPUT);
/*key1(P4_26)  key2(P2_22)  key3(P0_10)  */	

	GPIO_SetDir(5, (1<<4), GPIO_DIRECTION_INPUT);
	GPIO_SetDir(2, (1<<22), GPIO_DIRECTION_INPUT);
	GPIO_SetDir(0, (1<<10), GPIO_DIRECTION_INPUT);	
}


void key_printf(void)
{

 		/*key1(P4_26)  key2(P2_22)  key3(P0_10)  */
		if(!(GPIO_ReadValue(4) & (1<<26)))
        {
            while(  !(GPIO_ReadValue(4) & (1<<26))  );
            _printf("ֵ KEY1\r\n");
        }

//		key=1;
		if(!(GPIO_ReadValue(2) & (1<<22)))
        {
            while(!(GPIO_ReadValue(2) & (1<<22)));
            _printf("ֵ KEY2\r\n");
//		key=2;
		}

        if(!(GPIO_ReadValue(0) & (1<<10)))
        {   
            while(!(GPIO_ReadValue(0) & (1<<10)));
            _printf("ֵ KEY3\r\n");
//		key=3;
        }
		/*JOYSITCK  A(P2_25)  B(P2_26)  C(P2_23)  D(P2_19)  PRESS(P0_14)*/
		if(!(GPIO_ReadValue(2) & (1<<25)))
        {
            while(!(GPIO_ReadValue(2) & (1<<25)));
            _printf("ֵ KEY4\r\n");
//		key=1;
		}

        if(!(GPIO_ReadValue(2) & (1<<26)))
        { 
            while(!(GPIO_ReadValue(2) & (1<<26)));
            _printf("ֵ KEY5\r\n");
//		key=2;
		}

        if(!(GPIO_ReadValue(2) & (1<<23)))
        {
            while(!(GPIO_ReadValue(2) & (1<<23)));
            _printf("ֵ KEY6\r\n");
//		key=3;
		}

        if(!(GPIO_ReadValue(2) & (1<<19)))
        {
            while(!(GPIO_ReadValue(2) & (1<<19)));
            _printf("ֵ KEY7\r\n");
//		key=4;	
		}	
		if(!(GPIO_ReadValue(0) & (1<<14)))
        {
            while(!(GPIO_ReadValue(0) & (1<<14)));
            _printf("ֵ KEY8\r\n");
//		key=0;
        }
}



/*********************************************************************************************************
** Function name:			tickISRHandler
** Descriptions:			Timeout interrupt handler of system timer ϵͳʱʱж
** Input parameters:		None 
** Output parameters:		None 
** Returned value:		    None         
*********************************************************************************************************/
void  tickISRHandler (void)
{
    #if OS_CRITICAL_METHOD == 3
        OS_CPU_SR cpu_sr;
    #endif 

    OS_ENTER_CRITICAL();                         
    OSIntNesting++;
    OS_EXIT_CRITICAL();

    OSTimeTick();                                                       /*  Call uC/OS-II's OSTimeTick()*/

    OSIntExit();                                 
}                              

int main (void)
{         	
	uint32_t cclk = CLKPWR_GetCLK(CLKPWR_CLKTYPE_CPU);


	/* Generate interrupt each 1 ms   */
	SysTick_Config(cclk/1000 - 1);



    OSInit();                                                           /*  Initialize the kernel of uC */
   																		/*  ʼں                  */ 
	task1_Sem = OSSemCreate(1);
	task2_Sem = OSSemCreate(0);
                                                                    

    OSTaskCreate ( taskStart,                                          
		           (void *)0, 
				   &GstkStart[TASK_START_STK_SIZE-1], 
				   TASK_START_PRIO );                                   /*  Initialize the start task   */
                                                                        /*  ʼ              */  
    OSStart();                                                          /*  Start uC/OS-II uC/OS-II */
    return(0) ;
}


/*********************************************************************************************************
** Function name:           taskStart	   
** Descriptions:            Start task	
** input parameters:        *parg
** output parameters:             
** Returned value:           
*********************************************************************************************************/
static void taskStart (void  *parg)
{
    (void)parg;

    #if OS_TASK_STAT_EN > 0
    OSStatInit();                                                       /*  Enable statistics           */
                                                                        /*  ʹͳƹ                */
    #endif

  	/*
     *  Create the other tasks here. ﴴ
     */
    OSTaskCreate (taskLed1, (void *)0,   		
			      &GstkLed1[TASK_LED1_STK_SIZE-1], 
				  TASK_LED2_PRIO);                                       /*  ʼtaskLed           */ 

    OSTaskCreate (taskLed2, (void *)0,   		
			      &GstkLed2[TASK_LED2_STK_SIZE-1], 
				  TASK_LED1_PRIO);   
                                                      /*  ʼtaskLed           */ 
    OSTaskCreate (task_key, (void *)0,   		
			      &Gstkkey[TASK_key_STK_SIZE-1], 
				  TASK_key_PRIO); 

	while (1) {                             
        OSTaskSuspend(OS_PRIO_SELF);                                    /*  The start task can be pended*/
                                                                        /*  here.   */
    }

}



/*********************************************************************************************************
  The other tasks 
*********************************************************************************************************/
/*
 *  Add the other tasks here . 
 */

static  void  taskLed1 (void  *parg)
{
    (void)parg;
    while (1) 
    {
	    Led1();           	
        _printf("LED1\r\n");
		OSTimeDly(500);
		OSSemPost(task1_Sem);

	}
}

static  void  taskLed2 (void  *parg)
{
	(void)parg;
    while (1) {
		Led2();         	
        _printf("LED2\r\n");
		OSTimeDly(100);
		OSSemPost(task2_Sem);	
	}
}


static  void  task_key (void  *parg)
{
    (void)parg;

    GPIO_Configuration();
    debug_frmwrk_init();
    _printf("LPC1788 Ucosʵ飡\r\n");


    while(1)
    {
        key_printf();

       	OSTimeDly(100);
		OSSemPost(task3_Sem);
    }


}


/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
